#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <process.h>
#include "cfg.h"
#include "news2ml.h"

tagFIELDS2REMOVE FieldsToRemove[] = {{"From", FIELD_FROM},
                                     {"Received:", FIELD_RECEIVED},
                                     {"To:", FIELD_TO},
                                     {"Distribution:", FIELD_DISTRIBUTION},
                                     {"Cc:", FIELD_CC},
                                     {"Newsgroups:", FIELD_NEWSGROUPS},
                                     {"X-FTN-SEEN-BY:", FIELD_SEENBY}
                                    };
int nFields                       = sizeof(FieldsToRemove) / sizeof(FieldsToRemove[0]);
tagLISTSIDLIST *pLists            = NULL;
char *RMail                       = NULL;
char *Address                     = NULL;

int cfgparce(char *cfgname)
{
  int rc = 0;
  CfgStrings *pConfig = NULL;
  CfgStrings *pCurrent;
  
  if(cfgname != NULL)
  {
    if(!CfgRead(cfgname, &pConfig))
    {
      for(pCurrent = pConfig; pCurrent != NULL; pCurrent = pCurrent->Next)
      {
        if(!stricmp(pCurrent->name, "List"))
        {
          static char tmpfld1[128], tmpfld2[128];
          
          if(sscanf(pCurrent->data, "%s %s", tmpfld1, tmpfld2) == 2)
          {
            tagLISTSIDLIST *pNewList = (tagLISTSIDLIST*)malloc(sizeof(tagLISTSIDLIST));

            if(pNewList != NULL)
            {
              pNewList->pNext = pLists;
              pNewList->pName = strdup(tmpfld1);
              pNewList->pAddr = strdup(tmpfld2);
              
              pLists = pNewList;
            }
          }
        }
        else if(!stricmp(pCurrent->name, "RMail"))
        {
          RMail = strdup(pCurrent->data);
        }
      }
      
      CfgFree(pConfig);
      rc = 1;
    }
  }
  
  return rc;
}

void procstring(char *str, FILE *stream)
{
  static int lastfield = FIELD_OTHER;
  static int addrfound = 0;
  tagLISTSIDLIST *pCurList = pLists;
  int curfield;
  int fieldlen;

  if(isspace(str[0]))
    curfield = lastfield;
  else
  {
    curfield = lastfield = FIELD_OTHER;
    
    for(int i = 0; i < nFields; i++)
    {
      fieldlen = strlen(FieldsToRemove[i].pName);
      
      if(!strncmp(str, FieldsToRemove[i].pName, fieldlen) && 
         isspace(str[fieldlen]))
      {
        curfield = lastfield = FieldsToRemove[i].iCode;
        break;
      }
    }
  }
  
  if(!addrfound && curfield == FIELD_NEWSGROUPS)
  {
    for(pCurList = pLists; pCurList != NULL; pCurList = pCurList->pNext)
    {
      char *p = &str[fieldlen + 1];

      char *q = strchr(p, '\n');
      if(q != NULL)
        *q = '\0';
      q = strchr(p, '\r');
      if(q != NULL)
        *q = '\0';

      if(strcmp(p, pCurList->pName) == 0)
      {
        Address = pCurList->pAddr;
        addrfound = 1;
        break;
      }
    }
  }
  
  if(curfield == FIELD_OTHER)
    fputs(str, stream);
}

void procfile(char *fname)
{
  FILE *in = stdin;
  FILE *out;
  char *tmpfname = TEMPORARY_FILE_NAME;
  static char str[8196];

  if(fname != NULL)
  {
    in = fopen(fname, "rb");
    
    if(in == NULL)  
    {
      fprintf(stderr, "Couldn't open input file '%s'\n", fname);
      return;
    }
  }
  
  if(tmpfname != NULL)
  {
    out = fopen(tmpfname, "wb");

    if(out == NULL)  
    {
      fprintf(stderr, "Couldn't open temporary output file '%s'\n", tmpfname);
      return;
    }
  }
  else
  {
    fprintf(stderr, "Couldn't create temporary file name\n");
    return;
  }
  
  do
  {
    fgets(str, 8195, in);
    procstring(str, out);
  } while(!feof(in));
  
  if(fname != NULL)
    fclose(in);

  fclose(out);
  
  if(Address != NULL)
  {
    if(RMail == NULL)
      sprintf(str, "rmail %s < %s", Address, tmpfname);
    else
      sprintf(str, "%s %s < %s", RMail, Address, tmpfname);

    system(str);
  }
  
  unlink(tmpfname);
}

void main(int argc, char *argv[])
{
  static char cfg_path[_MAX_PATH];
  static char drive[_MAX_DRIVE];
  static char dir[_MAX_DIR];
  static char fname[_MAX_FNAME];
  static char ext[_MAX_EXT];

  _splitpath(argv[0], drive, dir, fname, ext);
  _makepath(cfg_path, drive, dir, fname, "cfg");

  if(cfgparce(cfg_path))
  {
    if(argc > 1)
      procfile(argv[1]);
    else
      procfile(NULL);
  }
  
  while(pLists != NULL)
  {
    tagLISTSIDLIST *pCurList = pLists;
    
    pLists = pLists->pNext;
    
    if(pCurList->pName)
      free(pCurList->pName);
    
    if(pCurList->pAddr)
      free(pCurList->pAddr);
      
    free(pCurList);
  };
  
  if(RMail != NULL)
    free(RMail);
  
  if(Address != NULL)  
    exit(0);  
  else
    exit(255);  
}


